#include "GraphicsVector.h"

XMFLOAT3 operator+(const XMFLOAT3& left,const XMFLOAT3& right)
{
  return XMFLOAT3(left.x + right.x,left.y + right.y,left.z + right.z);
}

XMFLOAT3 operator*(const XMFLOAT3& left,float right)
{
  return XMFLOAT3(left.x * right,left.y * right,left.z * right);
}

XMFLOAT3 operator*(float left,const XMFLOAT3& right)
{
  return right * left;
}

XMFLOAT4 operator-(const XMFLOAT4& left,const XMFLOAT4& right)
{
  return XMFLOAT4(
    left.x - right.x,
    left.y - right.y,
    left.z - right.z,
    left.w - right.w);
}

XMFLOAT4 operator*(const XMFLOAT4& left,float right)
{
  return XMFLOAT4(
    left.x * right,
    left.y * right,
    left.z * right,
    left.w * right);
}

XMFLOAT4& operator+=(XMFLOAT4& left,const XMFLOAT4& right)
{
  left.x += right.x;
  left.y += right.y;
  left.z += right.z;
  left.w += right.w;
  
  return left;
}
