#ifndef GRAPHICS_VECTOR_H
#define GRAPHICS_VECTOR_H

/// <summary>
/// Takes care of including the right files for access to the various math
/// vector data types and adds some commonly needed math operations for them
/// </summary>

#include <windows.h>
#include <xnamath.h>

XMFLOAT3 operator+(const XMFLOAT3& left,const XMFLOAT3& right);

XMFLOAT3 operator*(const XMFLOAT3& left,float right);
XMFLOAT3 operator*(float left,const XMFLOAT3& right);

XMFLOAT4 operator-(const XMFLOAT4& left,const XMFLOAT4& right);

XMFLOAT4 operator*(const XMFLOAT4& left,float right);

XMFLOAT4& operator+=(XMFLOAT4& left,const XMFLOAT4& right);

#endif /* GRAPHICS_VECTOR_H */
