#ifndef MESSAGE_IDS_H
#define MESSAGE_IDS_H

/// <summary>
/// Enum of message ids for the various network messages
/// </summary>
enum MessageIDs
{
  /// <summary>
  /// not a message id, but a place holder for 1 below the lowest valid
  /// message id
  /// </summary>
  MSG_ID_MIN,

  /// <summary>
  /// ID for messages rejecting a connection
  /// </summary>
  MSG_CONNECTION_REJECTED,

  /// <summary>
  /// ID for messages that are informing the other side of the connection
  /// being closed
  /// </summary>
  MSG_CLOSE_CONNECTION,

  /// <summary>
  /// ID for messages that are settting a single numeric value
  /// </summary>
  MSG_SET_SINGLE,

  /// <summary>
  /// ID for messages that are setting a string value
  /// </summary>
  MSG_SET_STRING,

  /// <summary>
  /// ID for messages that are specifying the entire color set
  /// </summary>
  MSG_COLOR_SET,

  /// <summary>
  /// ID for messages that are specifying the entire color sequence in order
  /// </summary>
  MSG_COLOR_SEQ,

  /// <summary>
  /// not a message id, but a place holder for 1 above the highest valid
  /// message id
  /// </summary>
  MSG_ID_MAX,
};

#endif /* MESSAGE_IDS_H */
