#include "MsgColorSeq.h"
using namespace std;

MsgColorSeq::MsgColorSeq(const vector<ColorSeqEntry>& val)
:m_val(val)
{
}

MsgColorSeq::~MsgColorSeq()
{
}

MsgColorSeq* MsgColorSeq::Create(char* data,int length)
{
  if (length < sizeof(int))
  {
    return NULL;
  }
  
  // position in data for what has been extracted so far
  int pos = 0;
  
  // extract the number of entries
  int num_entries = *(int*)(data + pos);
  pos += sizeof(num_entries);
  if (num_entries < 0)
  {
    return NULL;
  }
  else if ((num_entries * ColorSeqEntry::BytesInMessage() + sizeof(int))
    != length)
  {
    return NULL;
  }
  
  // create the storage for the entries
  vector<ColorSeqEntry> entries;
  entries.reserve(num_entries);
  
  // read each entry
  for (int i = 0; i < num_entries; ++i)
  {
    ColorSeqEntry entry(data,pos);
    entries.push_back(entry);
  }
  
  // return the new instance
  return new MsgColorSeq(entries);
}

MessageIDs MsgColorSeq::GetMessageID() const
{
  return MSG_COLOR_SEQ;
}

vector<ColorSeqEntry>& MsgColorSeq::GetValue()
{
  return m_val;
}

int MsgColorSeq::GetMessageLength() const
{
  // not implemented since it is not needed by the renderer
  return 0;
}

void MsgColorSeq::WriteContents(TCPSocket& socket) const
{
  // not implemented since it is not needed by the renderer
}
