#include "MsgColorSet.h"
using namespace std;

MsgColorSet::MsgColorSet(const vector<ColorSetEntry>& val)
:m_val(val)
{
}

MsgColorSet::~MsgColorSet()
{
}

MsgColorSet* MsgColorSet::Create(char* data,int length)
{
  if (length < sizeof(int))
  {
    return NULL;
  }
  
  // position in data for what has been extracted so far
  int pos = 0;
  
  // extract the number of entries
  int num_entries = *(int*)(data + pos);
  pos += sizeof(num_entries);
  if (num_entries < 0)
  {
    return NULL;
  }
  else if ((num_entries * ColorSetEntry::BytesInMessage() + sizeof(int))
    != length)
  {
    return NULL;
  }
  
  // create the storage for the entries
  vector<ColorSetEntry> entries;
  entries.reserve(num_entries);
  
  // read each entry
  for (int i = 0; i < num_entries; ++i)
  {
    ColorSetEntry entry(data,pos);
    entries.push_back(entry);
  }
  
  // return the new instance
  return new MsgColorSet(entries);
}

MessageIDs MsgColorSet::GetMessageID() const
{
  return MSG_COLOR_SET;
}

vector<ColorSetEntry>& MsgColorSet::GetValue()
{
  return m_val;
}

int MsgColorSet::GetMessageLength() const
{
  // not implemented since it is not needed by the renderer
  return 0;
}

void MsgColorSet::WriteContents(TCPSocket& socket) const
{
  // not implemented since it is not needed by the renderer
}
