#include "MsgSetSingle.h"

MsgSetSingle::MsgSetSingle(ParameterIDs id,float val)
:m_id(id),
 m_val(val)
{
}

MsgSetSingle::~MsgSetSingle()
{
}

MsgSetSingle* MsgSetSingle::Create(char* data,int length)
{
  if (length != (sizeof(int) + sizeof(float)))
  {
    return NULL;
  }
  
  // extract the parameter id
  int id = *(int*)data;
  if (id < PARAM_ID_MIN || id >= PARAM_ID_MAX)
  {
    return NULL;
  }
  
  // extract the value
  float val = *((float*)(data + sizeof(int)));
  
  // return the new instance
  return new MsgSetSingle((ParameterIDs)id,val);
}

MessageIDs MsgSetSingle::GetMessageID() const
{
  return MSG_SET_SINGLE;
}

ParameterIDs MsgSetSingle::GetParamID() const
{
  return m_id;
}

float MsgSetSingle::GetValue() const
{
  return m_val;
}

int MsgSetSingle::GetMessageLength() const
{
  // not implemented since it is not needed by the renderer
  return 0;
}

void MsgSetSingle::WriteContents(TCPSocket& socket) const
{
  // not implemented since it is not needed by the renderer
}
