#include "MsgSetString.h"
using namespace std;

MsgSetString::MsgSetString(ParameterIDs id,const string& val)
:m_id(id),
 m_val(val)
{
}

MsgSetString::~MsgSetString()
{
}

MsgSetString* MsgSetString::Create(char* data,int length)
{
  if (length < (2 * sizeof(int)))
  {
    return NULL;
  }
  
  // extract the parameter id
  int id = *(int*)data;
  if (id < PARAM_ID_MIN || id >= PARAM_ID_MAX)
  {
    return NULL;
  }
  
  // extract the string length
  int len = *(int*)(data + sizeof(int));
  if ((size_t)len > (length - 2 * sizeof(int)))
  {
    return NULL;
  }
  
  // return the new instance
  string tmp(data + 2* sizeof(int),len);
  return new MsgSetString((ParameterIDs)id,tmp);
}

MessageIDs MsgSetString::GetMessageID() const
{
  return MSG_SET_STRING;
}

ParameterIDs MsgSetString::GetParamID() const
{
  return m_id;
}

const string& MsgSetString::GetValue() const
{
  return m_val;
}

int MsgSetString::GetMessageLength() const
{
  // not implemented since it is not needed by the renderer
  return 0;
}

void MsgSetString::WriteContents(TCPSocket& socket) const
{
  // not implemented since it is not needed by the renderer
}
