#include "ColorSeqEntry.h"

int ColorSeqEntry::BytesInMessage()
{
  return sizeof(float) * 4;
}

ColorSeqEntry::ColorSeqEntry(char* data,int& offset)
{
  // load the color
  m_color.x = *((float*)(data + offset));
  offset += sizeof(float);
  m_color.y = *((float*)(data + offset));
  offset += sizeof(float);
  m_color.z = *((float*)(data + offset));
  offset += sizeof(float);

  // load the life
  m_life = *((float*)(data + offset));
  offset += sizeof(float);
}

ColorSeqEntry::ColorSeqEntry(XMFLOAT3 color,float life)
:m_color(color),
 m_life(life)
{
}

ColorSeqEntry::~ColorSeqEntry()
{
}

void ColorSeqEntry::SetLife(float life)
{
  m_life = life;
}

const XMFLOAT3& ColorSeqEntry::GetColor() const
{
  return m_color;
}

float ColorSeqEntry::GetLife() const
{
  return m_life;
}
