#include "ColorSetEntry.h"

int ColorSetEntry::BytesInMessage()
{
  return sizeof(float) * 4;
}

ColorSetEntry::ColorSetEntry(char* data,int& offset)
{
  // load the color
  m_color.x = *((float*)(data + offset));
  offset += sizeof(float);
  m_color.y = *((float*)(data + offset));
  offset += sizeof(float);
  m_color.z = *((float*)(data + offset));
  offset += sizeof(float);

  // load the chance
  m_chance = *((float*)(data + offset));
  offset += sizeof(float);
}

ColorSetEntry::ColorSetEntry(XMFLOAT3 color,float prob)
:m_color(color),
 m_chance(prob)
{
}

ColorSetEntry::~ColorSetEntry()
{
}

void ColorSetEntry::SetChance(float prob)
{
  m_chance = prob;
}

const XMFLOAT3& ColorSetEntry::GetColor() const
{
  return m_color;
}

float ColorSetEntry::GetChance() const
{
  return m_chance;
}
