﻿#include "PartialSphere.h"
#include <xnamath.h>

PartialSphere::PartialSphere()
:m_min_x(0),
 m_max_x(0),
 m_min_y(0),
 m_max_y(0)
{
}

XMVECTOR PartialSphere::GetDirection()
{
  float  yaw   = (float)rand() / RAND_MAX * (m_max_x - m_min_x) + m_min_x;
  float  pitch = (float)rand() / RAND_MAX * (m_max_y - m_min_y) + m_min_y;
  
  XMVECTOR dir = XMVectorSet(0,0,1,0);
  XMMATRIX rot = XMMatrixRotationRollPitchYaw(pitch,yaw,0);

  return XMVector4Transform(dir,rot);
}

void PartialSphere::SetMinX(float val)
{
  m_min_x = val;
}

void PartialSphere::SetMaxX(float val)
{
  m_max_x = val;
}

void PartialSphere::SetMinY(float val)
{
  m_min_y = val;
}

void PartialSphere::SetMaxY(float val)
{
  m_max_y = val;
}
