#ifndef EMITTER_SHAPE_BASE_H
#define EMITTER_SHAPE_BASE_H

#include <windows.h>
#include <xnamath.h>

/// <summary>
/// Base class for emitter shapes
/// </summary>
class EmitterShapeBase
{
  public:
    virtual ~EmitterShapeBase();
    
    /// <summary>
    /// Retrieves a position for a new particle based on the particular
    /// subtype's intented shape
    /// </summary>
    /// <returns>
    /// position for a new particle in the emitter's local space
    /// </returns>
    /// <remarks>
    /// This does not take into account scaling, rotation, etc since the
    /// particle system itself does that
    /// </remarks>
    virtual XMVECTOR SpawnPosition() = 0;
    
  private:
};

#endif /* EMITTER_SHAPE_BASE_H */
