#ifndef EMITTER_SHAPES_H
#define EMITTER_SHAPES_H

/// <summary>
/// Enum of the various emitter shapes
/// </summary>
/// <remarks>
/// Entries need to be in the same order that the editor UI is using for
/// showing them in its combo box so that the UI can just use the selected
/// index when determining the value to put in the message
/// </remarks>
enum EmitterShapes
{
  EMITTER_POINT = 0,
  EMITTER_LINE,
  EMITTER_SQUARE,
  EMITTER_SQUARE_PERIMETER,
  EMITTER_CIRCLE,
  EMITTER_RING,
  EMITTER_SPHERE,
  EMITTER_HEMISPHERE,
};

#endif /* EMITTER_SHAPES_H */
