﻿#ifndef HEMISPHERE_H
#define HEMISPHERE_H

#include "EmitterShapeBase.h"

/// <summary>
/// Hemisphere emitter that creates particles in a unit sphere and z >= 0 in
/// the emitter's local space, centered at the origin
/// </summary>
class Hemisphere : public EmitterShapeBase
{
  public:
    /// <summary>
    /// Retrieves a position for a new particle based on the particular
    /// subtype's intented shape
    /// </summary>
    /// <returns>
    /// position for a new particle in the emitter's local space
    /// </returns>
    /// <remarks>
    /// This does not take into account scaling, rotation, etc since the
    /// particle system itself does that
    /// </remarks>
    XMVECTOR SpawnPosition();
};

#endif /* HEMISPHERE_H */
