﻿#ifndef LINE_H
#define LINE_H

#include "EmitterShapeBase.h"

/// <summary>
/// Line emitter that creates particles along a unit length line that is
/// aligned along the emitter's local space's x axis and centered at the
/// origin
/// </summary>
class Line : public EmitterShapeBase
{
  public:
    /// <summary>
    /// Retrieves a position for a new particle based on the particular
    /// subtype's intented shape
    /// </summary>
    /// <returns>
    /// position for a new particle in the emitter's local space
    /// </returns>
    /// <remarks>
    /// This does not take into account scaling, rotation, etc since the
    /// particle system itself does that
    /// </remarks>
    XMVECTOR SpawnPosition();
};

#endif /* LINE_H */
