﻿#ifndef POINT_H
#define POINT_H

#include "EmitterShapeBase.h"

/// <summary>
/// Point emitter that creates particles in a the origin of the particle
/// system's local space
/// </summary>
class Point : public EmitterShapeBase
{
  public:
    /// <summary>
    /// Retrieves a position for a new particle based on the particular
    /// subtype's intented shape
    /// </summary>
    /// <returns>
    /// position for a new particle in the emitter's local space
    /// </returns>
    /// <remarks>
    /// This does not take into account scaling, rotation, etc since the
    /// particle system itself does that
    /// </remarks>
    XMVECTOR SpawnPosition();
};

#endif /* POINT_H */
