﻿#ifndef SQUARE_H
#define SQUARE_H

#include "EmitterShapeBase.h"

/// <summary>
/// Square emitter that creates particles in a 1x1 region in the xz plane in
/// the emitter's local space, centered at the origin
/// </summary>
class Square : public EmitterShapeBase
{
  public:
    /// <summary>
    /// Retrieves a position for a new particle based on the particular
    /// subtype's intented shape
    /// </summary>
    /// <returns>
    /// position for a new particle in the emitter's local space
    /// </returns>
    /// <remarks>
    /// This does not take into account scaling, rotation, etc since the
    /// particle system itself does that
    /// </remarks>
    XMVECTOR SpawnPosition();
};

#endif /* SQUARE_H */
