﻿#ifndef SQUARE_PERIMETER_H
#define SQUARE_PERIMETER_H

#include "EmitterShapeBase.h"

/// <summary>
/// Square perimeter emitter that creates particles along the edge of a 1x1
/// region in the xz plane in the emitter's local space, centered at the
/// origin
/// </summary>
class SquarePerimeter : public EmitterShapeBase
{
  public:
    /// <summary>
    /// Retrieves a position for a new particle based on the particular
    /// subtype's intented shape
    /// </summary>
    /// <returns>
    /// position for a new particle in the emitter's local space
    /// </returns>
    /// <remarks>
    /// This does not take into account scaling, rotation, etc since the
    /// particle system itself does that
    /// </remarks>
    XMVECTOR SpawnPosition();
};

#endif /* SQUARE_PERIMETER_H */
